window.networkAgent = new function () {           
       var me=this;
       this._eventLookup = {};
       
       this.error = new function () {
        
       };
       this.adaptiveStreaming = new function () {
        
       };
       this.contentServer = new function () {
        
       };
       this.usage = new function () {
        
       };
       
       function bindProperty(targetObject, propertyName, getMethodName, setMethodName) {
              if (!setMethodName) {
                     Object.defineProperty(targetObject, propertyName, {
                           get: function () {
                                  result = _networkAgent[getMethodName]();
                                  if(propertyName == "availablebitrates"){
                                    result = JSON.parse(_networkAgent[getMethodName]())[0];
                                  }
                                  return result;
                           }
                     });
              } else {
                     Object.defineProperty(targetObject, propertyName, {
                           get: function () {
                                  return _networkAgent[getMethodName]();
                           },
                           set: function (param) {
                                  return _networkAgent[setMethodName](param);
                           }
                     });
              }
       }
             
    bindProperty(this.error, "code", "getErrorCode");
    bindProperty(this.contentServer, "url", "getURL");
    bindProperty(this.contentServer, "finalurl", "getFinalURL");
    bindProperty(this.contentServer, "finalipaddress", "getFinalIPAddress");
    
    bindProperty(this.usage, "downloadbitrate", "getDownloadBitrate");
    bindProperty(this.usage, "downloadbitrateaverage", "getDownloadBitrateAverage");
    bindProperty(this.usage, "bytesdownloaded", "getBytesDownloaded");
    
    bindProperty(this.adaptiveStreaming, "selectedbitrate", "getSelectedBitRate");
    bindProperty(this.adaptiveStreaming, "availablebitrates", "getAvailableBitrates");
       
      
    this._fireEvent = function (eventName, payload) {
         if (this._eventLookup[eventName]) {
            this._eventLookup[eventName].forEach(function (callback) {
                callback(payload);
            });
        }
    };

    this.addEventListener = function (eventName, callback) {
        if (!this._eventLookup[eventName]) {
            this._eventLookup[eventName] = [];
        }
        this._eventLookup[eventName].push(callback);
    };

    this.removeEventListener = function (eventName, callback) {
        if (this._eventLookup[eventName]) {
            this._eventLookup[eventName] = this._eventLookup[eventName].filter(function (value) { return value !== callback; });
        }
    };
};
