window.videoAgent = new function () {           
	var me = this;
	this._eventLookup = {};
   
   function bindProperty(propertyName, getMethodName, setMethodName) {
          if (!setMethodName) {
                 Object.defineProperty(me, propertyName, {
                       get: function () {
                              return _videoAgent[getMethodName]();
                       }
                 });
          } else {
                 Object.defineProperty(me, propertyName, {
                       get: function () {
                              return _videoAgent[getMethodName]();
                       },
                       set: function (param) {
                              return _videoAgent[setMethodName](param);
                       }
                 });
          }
   }
   
   this.pause = function () {         
       _videoAgent.pause();
   };
   this.play = function () {         
       _videoAgent.play();
   };
   this.stop = function () {         
       _videoAgent.stop();
   };
   this.bringVideoToFront = function () {         
       _videoAgent.bringVideoToFront();
   };
   this.sendVideoToBack = function () {         
       _videoAgent.sendVideoToBack();
   };
   bindProperty("duration", "getDuration");
   bindProperty("src", "getSrc", "setSrc");
   bindProperty("currentTime", "getCurrentTime", "seekTo");
   bindProperty("currentSrc", "getSrc");
   bindProperty("seeking", "getSeeking");
   bindProperty("paused", "getPaused");
   bindProperty("ended", "getEnded");
   bindProperty("loop", "getLoop", "setLoop");
   bindProperty("controls", "getControls", "setControls");
   bindProperty("volume", "getVolume", "setVolume");
   bindProperty("error", "getErrorCode");
   bindProperty("muted", "getMuted");
   bindProperty("defaultPlaybackRate", "getDefaultPlaybackRate");
   bindProperty("playbackRate", "getPlaybackRate");
   bindProperty("readyState", "getReadyState");
   bindProperty("maximumbitrate", "getMaximumBitrate", "setMaximumBitrate");
       
    this._fireEvent = function (eventName, payload) {
         if (this._eventLookup[eventName]) {
            this._eventLookup[eventName].forEach(function (callback) {
                callback(payload);
            });
        }
    };
       
    this.addEventListener = function (eventName, callback) {
        if (!this._eventLookup[eventName]) {
            this._eventLookup[eventName] = [];
        }
        this._eventLookup[eventName].push(callback);
    };

    this.removeEventListener = function (eventName, callback) {
        if (this._eventLookup[eventName]) {
            this._eventLookup[eventName] = this._eventLookup[eventName].filter(function (value) { return value !== callback; });
        }
    };
    
    _videoAgent.setForceLandscapeVideo(true);
};
